@echo off

setlocal enabledelayedexpansion

echo Creatures 1 Community Edition Patcher v1.0
echo.

set gamepath=

rem Determine the game path:
if exist "C:\Program Files (x86)\Steam\steamapps\common\Creatures The Albian Years\Creatures 1\Creatures.exe" (
  set "gamepath=C:\Program Files (x86)\Steam\steamapps\common\Creatures The Albian Years\Creatures 1\"
)
if exist "C:\GOG Games\Creatures 1\Creatures.exe" (
  set "gamepath=C:\GOG Games\Creatures 1\"
)
if exist "C:\Program Files\Creatures 1\Creatures.exe" (
  set "gamepath=C:\Program Files\Creatures 1\"
)
if exist "C:\Program Files (x86)\GOG Galaxy\Games\Creatures 1\Creatures.exe" (
  set "gamepath=C:\Program Files (x86)\GOG Galaxy\Games\Creatures 1"
)

if "%gamepath%"=="" (
  echo Error: Creatures 1 executable not found in any of the expected locations. You may need to edit this script with the correct path to your game.
  pause
  exit /b 1
)

echo Found Creatures 1: %gamepath%
echo.

rem Check for backup Creatures.exe
if not exist "%gamepath%Unpatched_Creatures.exe" (
  echo Your original executable will be backed up to "%gamepath%Unpatched_Creatures.exe". Please don't delete this file, as it will be used as the base for future binary patches or to restore your original game.
  copy "%gamepath%Creatures.exe" "%gamepath%Unpatched_Creatures.exe"
)

rem Check for BPatch.exe
if not exist "%gamepath%BPatch.exe" (
  echo Error: BPatch.exe not found. Please download it and copy BPatch.exe to "%gamepath%".
  echo Download location: https://delphidabbler.com/software/bdiff
  pause
  exit /b 1
)

rem Find the highest numbered build_X.patch file
set maxbuild=0
for /r "%gamepath%" %%f in (build_*.patch) do (
  set filename=%%~nxf
  set buildnum=!filename:build_=!
  set buildnum=!buildnum:.patch=!
  set /a num=buildnum
  if !num! gtr !maxbuild! (
    set maxbuild=!num!
  )
)

if %maxbuild%==0 (
  echo Error: No build_X.patch file found. Please download the appropriate patch for your game and copy it to "%gamepath%".
  pause
  exit /b 1
)

set patchfile=%gamepath%build_%maxbuild%.patch"

echo Attempting to patch Creatures.exe to Community Build %maxbuild%...
echo.

"%gamepath%BPatch.exe" "%gamepath%Unpatched_Creatures.exe" "%gamepath%Creatures.exe" --input="%patchfile%"

if %errorlevel% neq 0 (
  echo Please ensure that this is a legitimately purchased, unmodified, copy of Creatures 1 from Steam or GoG.
  pause
  exit /b 1
)

echo Patching complete. You now have Community Build %maxbuild%.

set /p delete="Delete patch file? (y/n) "
if /i "%delete%"=="y" (
  del "%gamepath%build_%maxbuild%.patch"
)

pause
exit /b 0
